#include "tools.hpp"


string readBinary (string filename, int offset, int length)
{
    FILE * file = fileOpen(filename, "rb+");
    fseek(file, offset, SEEK_SET);

    char result[4096];
    for (int i = 0; i < 4096; i++) result[i]='\0';
    fread(result, sizeof(char), length, file);
    fclose(file);
    string line(result);
    return line;
}

void patchBinary (string filename, int offset, string newData)
{
    FILE * file = fileOpen(filename, "rb+");
    fseek(file, offset, SEEK_SET);
    fwrite(newData.c_str(), sizeof(char), newData.size(), file);
    fclose(file);
}

void patchBinaryB (string filename, int offset, string newData)
{
    FILE * file = fileOpen(filename, "rb+");

    fseek(file, offset, SEEK_SET);
    char blank = 0;
    for (int i=0; i< newData.size(); i++)
    {
        fwrite(newData.c_str() + i, sizeof(char), 1, file);
        fwrite(&blank, sizeof(char), 1, file);
    }    
    fclose(file);
}

string getSlotNumber (int slot)
{
    char tmp[3];
    tmp[0] = '0';
    tmp[1] = slot + '0'; 
    tmp[2] = '\0';
    string slotNumber (tmp);
    return (slotNumber);
}    
SectionType identifySectionType (string line)
{
    if (line == "[car names]") return NAMES;
    if (line == "[./cars/cars.ini data]") return PATHS;
    if (line == "[./misc/carinfo.ini car tech data]") return TECHDATA;
    if (line == "[./misc/ai/aidrv.ini team data]") return TEAMDATA;
    if (line == "[./misc/ai/aidrv.ini car data]") return CARDATA;
    return NONE;
    
}

FILE * fileOpen (string filename, string mode)
{
    // allow to read files when you want to read it (and not write it from scratch)
    if (mode.find("w") != string::npos)
    {
        string basecmd = "attrib -h -r -s /s ";
        basecmd.append("\"" + filename + "\"");
        system(basecmd.c_str());
    }
    
    FILE * file;
    file = fopen (filename.c_str(), mode.c_str());
    if (file  == NULL)
    {
        cout << endl;
        cout << "===============================================================================" << endl;
        cout << "Error! Could not open the following file" << endl;
        cout << "\"" << filename << "\"" << endl;
        cout << "Please check that:" << endl;
        cout << "\ta) The file exists." << endl;
        cout << "\tb) You have permission to read it." << endl;
        cout << "===============================================================================" << endl;
        exit (-3);
    }    
    return file;
}    

int stoi (const std::string & srcString)
{
    stringstream tmpString (srcString);
    int tmpInt;
    tmpString >> tmpInt;
    return tmpInt;
}

string freads (string filename, int line)
{
    int nline = 1;
    SectionType sectionType = NONE;
    const int linesize = 4096;
    char tmpline[linesize];
    FILE * file = fileOpen(filename, "r");
    while ( fgets (tmpline, linesize, file) )
    {
        if (nline == line)
        {
            string tmpstring (tmpline);
            return tmpstring;    
        }    
        nline++;
    }
    fclose (file);
}    

void freplaces (string filename, int line, string str)
{
    list <string> contents;
    
    int nline = 1;
    SectionType sectionType = NONE;
    const int linesize = 4096;
    char tmpline[linesize];
    FILE * file = fileOpen(filename, "r");
    while ( fgets (tmpline, linesize, file) )
    {
        string tmpstring (tmpline);
        contents.push_back (tmpstring);
        nline++;
    }
    fclose (file);
    
    file = fileOpen(filename, "w");
    list<string>::iterator it = contents.begin();
    for(int i=1; i < line; i++, it++)
    {
        fputs(it->c_str(), file);
    }
    str = str + "\n";
    fputs(str.c_str(), file);
    it++;
    for (;it != contents.end(); it++)
    {
        fputs(it->c_str(), file);
    }    
    fclose (file);
    
    contents.clear();
}
